diff --git a/pidgin/gtkconv.c b/pidgin/gtkconv.c
--- a/pidgin/gtkconv.c
+++ b/pidgin/gtkconv.c
@@ -3455,7 +2912,6 @@
 	PurpleConversation *conv;
 	PurpleConversationManager *manager;
 	PidginConversation *gtkconv;
-	PidginConvWindow *win;
 	gboolean visible = (gboolean)GPOINTER_TO_INT(value);
 
 	manager = purple_conversation_manager_get_default();
@@ -3470,12 +2926,13 @@
 		}
 
 		gtkconv = PIDGIN_CONVERSATION(conv);
-		win     = gtkconv->win;
-
+
+#if 0
 		gtk_toggle_action_set_active(
 		        GTK_TOGGLE_ACTION(win->menu->show_formatting_toolbar),
 		        visible
 		);
+#endif
 
 		talkatu_editor_set_toolbar_visible(TALKATU_EDITOR(gtkconv->editor), visible);
 
@@ -3923,12 +3380,8 @@
 #endif
 
 	/* Connect callbacks. */
-	purple_prefs_connect_callback(handle, PIDGIN_PREFS_ROOT "/conversations/close_on_tabs",
-								close_on_tabs_pref_cb, NULL);
 	purple_prefs_connect_callback(handle, PIDGIN_PREFS_ROOT "/conversations/show_formatting_toolbar",
 								show_formatting_toolbar_pref_cb, NULL);
-	purple_prefs_connect_callback(handle, PIDGIN_PREFS_ROOT "/conversations/tab_side",
-								tab_side_pref_cb, NULL);
 
 	/**********************************************************************
 	 * Register signals
@@ -4001,10 +3454,6 @@
 	purple_conversations_set_ui_ops(&conversation_ui_ops);
 
 	/* Callbacks to update a conversation */
-	purple_signal_connect(blist_handle, "blist-node-added", handle,
-						G_CALLBACK(buddy_update_cb), NULL);
-	purple_signal_connect(blist_handle, "blist-node-removed", handle,
-						G_CALLBACK(buddy_update_cb), NULL);
 	purple_signal_connect(blist_handle, "buddy-signed-on",
 						handle, PURPLE_CALLBACK(update_buddy_sign), "on");
 	purple_signal_connect(blist_handle, "buddy-signed-off",
@@ -4095,98 +3544,10 @@
 #include "gtkutils.h"
 #include "pidginmenutray.h"
 
-static void
-do_close(GtkWidget *w, int resp, PidginConvWindow *win)
-{
-	gtk_widget_destroy(warn_close_dialog);
-	warn_close_dialog = NULL;
-
-	if (resp == GTK_RESPONSE_OK)
-		pidgin_conv_window_destroy(win);
-}
-
-static void
-build_warn_close_dialog(PidginConvWindow *gtkwin)
-{
-	GtkWidget *label, *vbox, *hbox, *img;
-
-	g_return_if_fail(warn_close_dialog == NULL);
-
-	warn_close_dialog = gtk_dialog_new_with_buttons(_("Confirm close"),
-							GTK_WINDOW(gtkwin->window), GTK_DIALOG_MODAL,
-							_("Cancel"), GTK_RESPONSE_CANCEL,
-							_("Close"), GTK_RESPONSE_OK, NULL);
-
-	gtk_dialog_set_default_response(GTK_DIALOG(warn_close_dialog),
-	                                GTK_RESPONSE_OK);
-
-	gtk_container_set_border_width(GTK_CONTAINER(warn_close_dialog),
-	                               6);
-	gtk_window_set_resizable(GTK_WINDOW(warn_close_dialog), FALSE);
-
-	/* Setup the outside spacing. */
-	vbox = gtk_dialog_get_content_area(GTK_DIALOG(warn_close_dialog));
-
-	gtk_box_set_spacing(GTK_BOX(vbox), 12);
-	gtk_container_set_border_width(GTK_CONTAINER(vbox), 6);
-
-	img = gtk_image_new_from_icon_name("dialog-warning",
-			GTK_ICON_SIZE_DIALOG);
-
-	/* Setup the inner hbox and put the dialog's icon in it. */
-	hbox = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 12);
-	gtk_container_add(GTK_CONTAINER(vbox), hbox);
-	gtk_box_pack_start(GTK_BOX(hbox), img, FALSE, FALSE, 0);
-	gtk_widget_set_halign(img, GTK_ALIGN_START);
-	gtk_widget_set_valign(img, GTK_ALIGN_START);
-
-	/* Setup the right vbox. */
-	vbox = gtk_box_new(GTK_ORIENTATION_VERTICAL, 12);
-	gtk_container_add(GTK_CONTAINER(hbox), vbox);
-
-	label = gtk_label_new(_("You have unread messages. Are you sure you want to close the window?"));
-	gtk_widget_set_size_request(label, 350, -1);
-	gtk_label_set_line_wrap(GTK_LABEL(label), TRUE);
-	gtk_label_set_xalign(GTK_LABEL(label), 0);
-	gtk_label_set_yalign(GTK_LABEL(label), 0);
-	gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 0);
-
-	/* Connect the signals. */
-	g_signal_connect(G_OBJECT(warn_close_dialog), "response",
-	                 G_CALLBACK(do_close), gtkwin);
-
-}
-
 /**************************************************************************
  * Callbacks
  **************************************************************************/
 
-static gboolean
-close_win_cb(GtkWidget *w, GdkEventAny *e, gpointer d)
-{
-	PidginConvWindow *win = d;
-	GList *l;
-
-	/* If there are unread messages then show a warning dialog */
-	for (l = pidgin_conv_window_get_gtkconvs(win);
-	     l != NULL; l = l->next)
-	{
-		PidginConversation *gtkconv = l->data;
-		if (PURPLE_IS_IM_CONVERSATION(gtkconv->active_conv) &&
-				gtkconv->unseen_state >= PIDGIN_UNSEEN_TEXT)
-		{
-			build_warn_close_dialog(win);
-			gtk_widget_show_all(warn_close_dialog);
-
-			return TRUE;
-		}
-	}
-
-	pidgin_conv_window_destroy(win);
-
-	return TRUE;
-}
-
 static void
 conv_set_unseen(PurpleConversation *conv, PidginUnseenState state)
 {
@@ -4242,641 +3603,16 @@
 	purple_conversation_update(gtkconv->active_conv, PURPLE_CONVERSATION_UPDATE_UNSEEN);
 }
 
-/*
- * When a conversation window is focused, we know the user
- * has looked at it so we know there are no longer unseen
- * messages.
- */
-static gboolean
-focus_win_cb(GtkWidget *w, GdkEventFocus *e, gpointer d)
-{
-	PidginConvWindow *win = d;
-	PidginConversation *gtkconv = pidgin_conv_window_get_active_gtkconv(win);
-
-	if (gtkconv)
-		gtkconv_set_unseen(gtkconv, PIDGIN_UNSEEN_NONE);
-
-	return FALSE;
-}
-
-static void
-before_switch_conv_cb(GtkNotebook *notebook, GtkWidget *page, gint page_num,
-                      gpointer user_data)
-{
-	PidginConvWindow *win;
-	PurpleConversation *conv;
-	PidginConversation *gtkconv;
-
-	win = user_data;
-	conv = pidgin_conv_window_get_active_conversation(win);
-
-	g_return_if_fail(conv != NULL);
-
-	if (!PURPLE_IS_IM_CONVERSATION(conv))
-		return;
-
-	gtkconv = PIDGIN_CONVERSATION(conv);
-
-	if (gtkconv->u.im->typing_timer != 0) {
-		g_source_remove(gtkconv->u.im->typing_timer);
-		gtkconv->u.im->typing_timer = 0;
-	}
-}
-
-static gboolean
-window_keypress_cb(GtkWidget *widget, GdkEventKey *event, PidginConvWindow *win)
-{
-	PidginConversation *gtkconv = pidgin_conv_window_get_active_gtkconv(win);
-
-	return conv_keypress_common(gtkconv, event);
-}
-
-static void
-switch_conv_cb(GtkNotebook *notebook, GtkWidget *page, gint page_num,
-               gpointer user_data)
-{
-	PidginConvWindow *win;
-	PurpleConversation *conv;
-	PidginConversation *gtkconv;
-
-	win = user_data;
-	gtkconv = pidgin_conv_window_get_gtkconv_at_index(win, page_num);
-	conv = gtkconv->active_conv;
-
-	g_return_if_fail(conv != NULL);
-
-	gtkconv_set_unseen(gtkconv, PIDGIN_UNSEEN_NONE);
-
-	pidgin_conv_switch_active_conversation(conv);
-
-	purple_signal_emit(pidgin_conversations_get_handle(), "conversation-switched", conv);
-}
-
 /**************************************************************************
  * GTK window ops
  **************************************************************************/
-
-GList *
-pidgin_conv_windows_get_list()
-{
-	return window_list;
-}
-
-static gboolean gtk_conv_configure_cb(GtkWidget *w, GdkEventConfigure *event, gpointer data) {
-	GdkMonitor *monitor = NULL;
-	GdkRectangle geo, window_geo, intersect_geo;
-
-	if(!gtk_widget_get_visible(w)) {
-		return FALSE; /* carry on normally */
-	}
-
-	gtk_window_get_position(GTK_WINDOW(w), &window_geo.x, &window_geo.y);
-	window_geo.width = event->width;
-	window_geo.height = event->height;
-
-	/* Workaround for GTK bug # 169811 - "configure_event" is fired
-	* when the window is being maximized */
-	if (gdk_window_get_state(gtk_widget_get_window(w)) & GDK_WINDOW_STATE_MAXIMIZED)
-		return FALSE;
-
-	monitor = gdk_display_get_monitor_at_window(gdk_display_get_default(),
-	                                            event->window);
-	gdk_monitor_get_geometry(monitor, &geo);
-
-	/* now make sure that the window is entirely within the monitor.  We do
-	 * this by finding the intersection of the window on the monitor, if that
-	 * is equal to the window's geometry, then the window is fully contained on
-	 * the given monitor.
-	 */
-	gdk_rectangle_intersect(&geo, &window_geo, &intersect_geo);
-	if(!gdk_rectangle_equal(&window_geo, &intersect_geo)) {
-		return FALSE; /* carry on normally */
-	}
-
-	/* store the position */
-	purple_prefs_set_int(PIDGIN_PREFS_ROOT "/conversations/im/x", window_geo.x);
-	purple_prefs_set_int(PIDGIN_PREFS_ROOT "/conversations/im/y", window_geo.y);
-	purple_prefs_set_int(PIDGIN_PREFS_ROOT "/conversations/im/width",
-	                     window_geo.width);
-	purple_prefs_set_int(PIDGIN_PREFS_ROOT "/conversations/im/height",
-	                     window_geo.height);
-
-	/* continue to handle event normally */
-	return FALSE;
-}
-
 static void
-pidgin_conv_set_position_size(PidginConvWindow *win, int conv_x, int conv_y,
-		int conv_width, int conv_height)
-{
-	/* if the window exists, is hidden, we're saving positions, and the
-	 * position is sane... */
-	if (win && win->window &&
-			!gtk_widget_get_visible(win->window) && conv_width != 0) {
-
-#ifdef _WIN32  /* only override window manager placement on Windows */
-		/* ...check position is on screen... */
-		if (conv_x >= gdk_screen_width())
-			conv_x = gdk_screen_width() - 100;
-		else if (conv_x + conv_width < 0)
-			conv_x = 100;
-
-		if (conv_y >= gdk_screen_height())
-			conv_y = gdk_screen_height() - 100;
-		else if (conv_y + conv_height < 0)
-			conv_y = 100;
-
-		/* ...and move it back. */
-		gtk_window_move(GTK_WINDOW(win->window), conv_x, conv_y);
-#endif
-		gtk_window_resize(GTK_WINDOW(win->window), conv_width, conv_height);
-	}
-}
-
-static void
-pidgin_conv_restore_position(PidginConvWindow *win) {
-	pidgin_conv_set_position_size(win,
-		purple_prefs_get_int(PIDGIN_PREFS_ROOT "/conversations/im/x"),
-		purple_prefs_get_int(PIDGIN_PREFS_ROOT "/conversations/im/y"),
-		purple_prefs_get_int(PIDGIN_PREFS_ROOT "/conversations/im/width"),
-		purple_prefs_get_int(PIDGIN_PREFS_ROOT "/conversations/im/height"));
-}
-
-PidginConvWindow *
-pidgin_conv_window_new()
-{
-	PidginConvWindow *win;
-	GtkWidget *testidea;
-	GtkWidget *menubar;
-	GdkModifierType state;
-
-	win = g_malloc0(sizeof(PidginConvWindow));
-	win->menu = g_malloc0(sizeof(PidginConvWindowMenu));
-
-	window_list = g_list_append(window_list, win);
-
-	/* Create the window. */
-	win->window = pidgin_conversation_window_new();
-	/*_pidgin_widget_set_accessible_name(win->window, "Conversations");*/
-	if(!gtk_get_current_event_state(&state)) {
-		gtk_window_set_focus_on_map(GTK_WINDOW(win->window), FALSE);
-	}
-
-	/* Etan: I really think this entire function call should happen only
-	 * when we are on Windows but I was informed that back before we used
-	 * to save the window position we stored the window size, so I'm
-	 * leaving it for now. */
-#if TRUE || defined(_WIN32)
-	pidgin_conv_restore_position(win);
-#endif
-
-	g_signal_connect(G_OBJECT(win->window), "delete_event",
-	                 G_CALLBACK(close_win_cb), win);
-	g_signal_connect(G_OBJECT(win->window), "focus_in_event",
-	                 G_CALLBACK(focus_win_cb), win);
-
-	/* Intercept keystrokes from the menu items */
-	g_signal_connect(G_OBJECT(win->window), "key_press_event",
-					 G_CALLBACK(window_keypress_cb), win);
-
-
-	/* Create the notebook. */
-	win->notebook = gtk_notebook_new();
-
-	gtk_notebook_set_tab_pos(GTK_NOTEBOOK(win->notebook), GTK_POS_LEFT);
-	gtk_notebook_set_scrollable(GTK_NOTEBOOK(win->notebook), TRUE);
-	gtk_notebook_set_show_tabs(GTK_NOTEBOOK(win->notebook), FALSE);
-	gtk_notebook_set_show_border(GTK_NOTEBOOK(win->notebook), TRUE);
-
-	gtk_widget_show(win->notebook);
-
-	g_signal_connect(G_OBJECT(win->notebook), "switch_page",
-	                 G_CALLBACK(before_switch_conv_cb), win);
-	g_signal_connect_after(G_OBJECT(win->notebook), "switch_page",
-	                       G_CALLBACK(switch_conv_cb), win);
-
-	testidea = pidgin_conversation_window_get_vbox(PIDGIN_CONVERSATION_WINDOW(win->window));
-
-	/* Setup the menubar. */
-	menubar = setup_menubar(win);
-	gtk_box_pack_start(GTK_BOX(testidea), menubar, FALSE, TRUE, 0);
-
-	gtk_box_pack_start(GTK_BOX(testidea), win->notebook, TRUE, TRUE, 0);
-
-#ifdef _WIN32
-	g_signal_connect(G_OBJECT(win->window), "show",
-	                 G_CALLBACK(winpidgin_ensure_onscreen), win->window);
-
-	if (purple_prefs_get_bool(PIDGIN_PREFS_ROOT "/win32/minimize_new_convs")
-			&& !gtk_get_current_event_state(&state))
-		gtk_window_iconify(GTK_WINDOW(win->window));
-#endif
-
-	purple_signal_emit(pidgin_conversations_get_handle(),
-		"conversation-window-created", win);
-
-	return win;
-}
-
-void
-pidgin_conv_window_destroy(PidginConvWindow *win)
-{
-	if (win->gtkconvs) {
-		GList *iter = win->gtkconvs;
-		while (iter)
-		{
-			PidginConversation *gtkconv = iter->data;
-			iter = iter->next;
-			close_conv_cb(NULL, gtkconv);
-		}
-		return;
-	}
-
-	purple_prefs_disconnect_by_handle(win);
-	window_list = g_list_remove(window_list, win);
-
-	gtk_widget_destroy(win->window);
-
-	g_object_unref(G_OBJECT(win->menu->ui));
-
-	purple_notify_close_with_handle(win);
-	purple_signals_disconnect_by_handle(win);
-
-	g_free(win->menu);
-	g_free(win);
-}
-
-void
-pidgin_conv_window_show(PidginConvWindow *win)
-{
-	gtk_widget_show(win->window);
-}
-
-void
-pidgin_conv_window_hide(PidginConvWindow *win)
-{
-	gtk_widget_hide(win->window);
-}
-
-void
-pidgin_conv_window_raise(PidginConvWindow *win)
-{
-	gdk_window_raise(GDK_WINDOW(gtk_widget_get_window(win->window)));
-}
-
-void
-pidgin_conv_window_switch_gtkconv(PidginConvWindow *win, PidginConversation *gtkconv)
-{
-	gtk_notebook_set_current_page(GTK_NOTEBOOK(win->notebook),
-	                              gtk_notebook_page_num(GTK_NOTEBOOK(win->notebook),
-		                              gtkconv->tab_cont));
-}
-
-static gboolean
-gtkconv_tab_set_tip(GtkWidget *widget, GdkEventCrossing *event, PidginConversation *gtkconv)
-{
-	PangoLayout *layout;
-
-	layout = gtk_label_get_layout(GTK_LABEL(gtkconv->tab_label));
-	if (pango_layout_is_ellipsized(layout))
-		gtk_widget_set_tooltip_text(widget, gtk_label_get_text(GTK_LABEL(gtkconv->tab_label)));
-	else
-		gtk_widget_set_tooltip_text(widget, NULL);
-
-	return FALSE;
-}
-
-static void
-set_default_tab_colors(GtkWidget *widget)
-{
-	GtkCssProvider *provider = gtk_css_provider_new();
-	const gchar *res = "/im/pidgin/Pidgin3/Conversations/tab-label.css";
-
-	gtk_css_provider_load_from_resource(provider, res);
-
-	gtk_style_context_add_provider(gtk_widget_get_style_context(widget),
-	                               GTK_STYLE_PROVIDER(provider),
-	                               GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
+pidgin_conv_placement_place(PidginConversation *conv) {
+	GtkWidget *window = NULL;
+	PidginConversationWindow *conv_window = NULL;
+
+	window = pidgin_conversation_window_get_default();
+	conv_window = PIDGIN_CONVERSATION_WINDOW(window);
+
+	pidgin_conversation_window_add(conv_window, conv->active_conv);
 }
-
-void
-pidgin_conv_window_add_gtkconv(PidginConvWindow *win, PidginConversation *gtkconv)
-{
-	PurpleConversation *conv = gtkconv->active_conv;
-	PidginConversation *focus_gtkconv;
-	GtkWidget *tab_cont = gtkconv->tab_cont;
-	const gchar *tmp_lab;
-
-	win->gtkconvs = g_list_append(win->gtkconvs, gtkconv);
-	gtkconv->win = win;
-
-	if (win->gtkconvs && win->gtkconvs->next && win->gtkconvs->next->next == NULL)
-		pidgin_conv_tab_pack(win, ((PidginConversation*)win->gtkconvs->data));
-
-
-	/* Close button. */
-	gtkconv->close = pidgin_close_button_new();
-	g_signal_connect(gtkconv->close, "clicked", G_CALLBACK (close_conv_cb), gtkconv);
-
-	/* Status icon. */
-	if(PURPLE_IS_IM_CONVERSATION(conv)) {
-		PurpleBuddy *buddy = NULL;
-		PurplePresence *presence = NULL;
-
-		buddy = purple_blist_find_buddy(purple_conversation_get_account(conv),
-		                                purple_conversation_get_name(conv));
-
-		if(PURPLE_IS_BUDDY(buddy)) {
-			presence = purple_buddy_get_presence(buddy);
-		}
-
-		gtkconv->icon = pidgin_presence_icon_new(presence, "person",
-		                                         GTK_ICON_SIZE_MENU);
-		gtkconv->menu_icon = pidgin_presence_icon_new(presence, "person",
-		                                              GTK_ICON_SIZE_MENU);
-	} else {
-		gtkconv->icon = pidgin_presence_icon_new(NULL, "chat",
-		                                         GTK_ICON_SIZE_MENU);
-		gtkconv->menu_icon = pidgin_presence_icon_new(NULL, "chat",
-		                                              GTK_ICON_SIZE_MENU);
-	}
-	gtk_widget_show(gtkconv->icon);
-
-	/* Tab label. */
-	gtkconv->tab_label = gtk_label_new(tmp_lab = purple_conversation_get_title(conv));
-	set_default_tab_colors(gtkconv->tab_label);
-	gtk_widget_set_name(gtkconv->tab_label, "tab-label");
-
-	gtkconv->menu_tabby = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 6);
-	gtkconv->menu_label = gtk_label_new(tmp_lab);
-	gtk_box_pack_start(GTK_BOX(gtkconv->menu_tabby), gtkconv->menu_icon, FALSE, FALSE, 0);
-
-	gtk_widget_show_all(gtkconv->menu_icon);
-
-	gtk_box_pack_start(GTK_BOX(gtkconv->menu_tabby), gtkconv->menu_label, TRUE, TRUE, 0);
-	gtk_widget_show(gtkconv->menu_label);
-	gtk_label_set_xalign(GTK_LABEL(gtkconv->menu_label), 0);
-	gtk_label_set_yalign(GTK_LABEL(gtkconv->menu_label), 0);
-
-	gtk_widget_show(gtkconv->menu_tabby);
-
-	/* Build and set conversations tab */
-	pidgin_conv_tab_pack(win, gtkconv);
-
-	gtk_notebook_set_menu_label(GTK_NOTEBOOK(win->notebook), tab_cont, gtkconv->menu_tabby);
-
-	gtk_widget_show(tab_cont);
-
-	if (pidgin_conv_window_get_gtkconv_count(win) == 1) {
-		/* Er, bug in notebooks? Switch to the page manually. */
-		gtk_notebook_set_current_page(GTK_NOTEBOOK(win->notebook), 0);
-	} else {
-		gtk_notebook_set_show_tabs(GTK_NOTEBOOK(win->notebook), TRUE);
-	}
-
-	focus_gtkconv = g_list_nth_data(pidgin_conv_window_get_gtkconvs(win),
-	                             gtk_notebook_get_current_page(GTK_NOTEBOOK(win->notebook)));
-	gtk_widget_grab_focus(focus_gtkconv->editor);
-}
-
-static void
-pidgin_conv_tab_pack(PidginConvWindow *win, PidginConversation *gtkconv)
-{
-	gboolean tabs_side = FALSE;
-	gint angle = 0;
-	GtkWidget *first, *third, *ebox, *parent;
-
-	if (purple_prefs_get_int(PIDGIN_PREFS_ROOT "/conversations/tab_side") == GTK_POS_LEFT ||
-	    purple_prefs_get_int(PIDGIN_PREFS_ROOT "/conversations/tab_side") == GTK_POS_RIGHT)
-		tabs_side = TRUE;
-	else if (purple_prefs_get_int(PIDGIN_PREFS_ROOT "/conversations/tab_side") == (GTK_POS_LEFT|8))
-		angle = 90;
-	else if (purple_prefs_get_int(PIDGIN_PREFS_ROOT "/conversations/tab_side") == (GTK_POS_RIGHT|8))
-		angle = 270;
-
-	if (!angle) {
-		g_object_set(G_OBJECT(gtkconv->tab_label), "ellipsize", PANGO_ELLIPSIZE_END,  NULL);
-		gtk_label_set_width_chars(GTK_LABEL(gtkconv->tab_label), 4);
-	} else {
-		g_object_set(G_OBJECT(gtkconv->tab_label), "ellipsize", PANGO_ELLIPSIZE_NONE, NULL);
-		gtk_label_set_width_chars(GTK_LABEL(gtkconv->tab_label), -1);
-	}
-
-	if (tabs_side) {
-		gtk_label_set_width_chars(
-			GTK_LABEL(gtkconv->tab_label),
-			MIN(g_utf8_strlen(gtk_label_get_text(GTK_LABEL(gtkconv->tab_label)), -1), 12)
-		);
-	}
-
-	gtk_label_set_angle(GTK_LABEL(gtkconv->tab_label), angle);
-
-	if (angle)
-		gtkconv->tabby = gtk_box_new(GTK_ORIENTATION_VERTICAL, 6);
-	else
-		gtkconv->tabby = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 6);
-	gtk_widget_set_name(gtkconv->tabby, "tab-container");
-
-	/* select the correct ordering for vertical tabs */
-	if (angle == 90) {
-		first = gtkconv->close;
-		third = gtkconv->icon;
-	} else {
-		first = gtkconv->icon;
-		third = gtkconv->close;
-	}
-
-	ebox = gtk_event_box_new();
-	gtk_event_box_set_visible_window(GTK_EVENT_BOX(ebox), FALSE);
-	gtk_container_add(GTK_CONTAINER(ebox), gtkconv->tabby);
-	g_signal_connect(G_OBJECT(ebox), "enter-notify-event",
-			G_CALLBACK(gtkconv_tab_set_tip), gtkconv);
-
-	parent = gtk_widget_get_parent(gtkconv->tab_label);
-	if (parent != NULL) {
-		/* reparent old widgets on preference changes */
-		g_object_ref(first);
-		g_object_ref(gtkconv->tab_label);
-		g_object_ref(third);
-		gtk_container_remove(GTK_CONTAINER(parent), first);
-		gtk_container_remove(GTK_CONTAINER(parent), gtkconv->tab_label);
-		gtk_container_remove(GTK_CONTAINER(parent), third);
-	}
-
-	gtk_box_pack_start(GTK_BOX(gtkconv->tabby), first,              FALSE, FALSE, 0);
-	gtk_box_pack_start(GTK_BOX(gtkconv->tabby), gtkconv->tab_label, TRUE,  TRUE,  0);
-	gtk_box_pack_start(GTK_BOX(gtkconv->tabby), third,              FALSE, FALSE, 0);
-
-	if (parent == NULL) {
-		/* Add this pane to the conversation's notebook. */
-		gtk_notebook_append_page(GTK_NOTEBOOK(win->notebook), gtkconv->tab_cont, ebox);
-	} else {
-		/* reparent old widgets on preference changes */
-		g_object_unref(first);
-		g_object_unref(gtkconv->tab_label);
-		g_object_unref(third);
-
-		/* Reset the tabs label to the new version */
-		gtk_notebook_set_tab_label(GTK_NOTEBOOK(win->notebook), gtkconv->tab_cont, ebox);
-	}
-
-	gtk_container_child_set(GTK_CONTAINER(win->notebook), gtkconv->tab_cont,
-	                        "tab-expand", !tabs_side && !angle,
-	                        "tab-fill", TRUE, NULL);
-
-	if (pidgin_conv_window_get_gtkconv_count(win) == 1) {
-		gboolean show_tabs = purple_prefs_get_bool(PIDGIN_PREFS_ROOT "/conversations/tabs");
-		gint tab_side = purple_prefs_get_int(PIDGIN_PREFS_ROOT "/conversations/tab_side");
-
-		if(show_tabs) {
-			if(tab_side == GTK_POS_TOP) {
-				gtk_notebook_set_show_tabs(GTK_NOTEBOOK(win->notebook), FALSE);
-			} else {
-				gtk_notebook_set_show_tabs(GTK_NOTEBOOK(win->notebook), TRUE);
-			}
-		} else {
-			gtk_notebook_set_show_tabs(GTK_NOTEBOOK(win->notebook), FALSE);
-		}
-	}
-
-	/* show the widgets */
-/*	gtk_widget_show(gtkconv->icon); */
-	gtk_widget_show(gtkconv->tab_label);
-	if (purple_prefs_get_bool(PIDGIN_PREFS_ROOT "/conversations/close_on_tabs"))
-		gtk_widget_show(gtkconv->close);
-	gtk_widget_show(gtkconv->tabby);
-	gtk_widget_show(ebox);
-}
-
-void
-pidgin_conv_window_remove_gtkconv(PidginConvWindow *win, PidginConversation *gtkconv)
-{
-	unsigned int index;
-
-	index = gtk_notebook_page_num(GTK_NOTEBOOK(win->notebook), gtkconv->tab_cont);
-
-	g_object_ref_sink(G_OBJECT(gtkconv->tab_cont));
-
-	gtk_notebook_remove_page(GTK_NOTEBOOK(win->notebook), index);
-
-	win->gtkconvs = g_list_remove(win->gtkconvs, gtkconv);
-
-	g_signal_handlers_disconnect_matched(win->window, G_SIGNAL_MATCH_DATA,
-			0, 0, NULL, NULL, gtkconv);
-
-	if (win->gtkconvs && win->gtkconvs->next == NULL) {
-		pidgin_conv_tab_pack(win, win->gtkconvs->data);
-	}
-
-	if (!win->gtkconvs) {
-		pidgin_conv_window_destroy(win);
-	}
-}
-
-PidginConversation *
-pidgin_conv_window_get_gtkconv_at_index(const PidginConvWindow *win, int index)
-{
-	GtkWidget *tab_cont;
-
-	if (index == -1)
-		index = 0;
-	tab_cont = gtk_notebook_get_nth_page(GTK_NOTEBOOK(win->notebook), index);
-	return tab_cont ? g_object_get_data(G_OBJECT(tab_cont), "PidginConversation") : NULL;
-}
-
-PidginConversation *
-pidgin_conv_window_get_active_gtkconv(const PidginConvWindow *win)
-{
-	int index;
-	GtkWidget *tab_cont;
-
-	index = gtk_notebook_get_current_page(GTK_NOTEBOOK(win->notebook));
-	if (index == -1)
-		index = 0;
-	tab_cont = gtk_notebook_get_nth_page(GTK_NOTEBOOK(win->notebook), index);
-	if (!tab_cont)
-		return NULL;
-	return g_object_get_data(G_OBJECT(tab_cont), "PidginConversation");
-}
-
-
-PurpleConversation *
-pidgin_conv_window_get_active_conversation(const PidginConvWindow *win)
-{
-	PidginConversation *gtkconv;
-
-	gtkconv = pidgin_conv_window_get_active_gtkconv(win);
-	return gtkconv ? gtkconv->active_conv : NULL;
-}
-
-gboolean
-pidgin_conv_window_is_active_conversation(const PurpleConversation *conv)
-{
-	return conv == pidgin_conv_window_get_active_conversation(PIDGIN_CONVERSATION(conv)->win);
-}
-
-gboolean
-pidgin_conv_window_has_focus(PidginConvWindow *win)
-{
-	gboolean has_focus = FALSE;
-
-	g_object_get(G_OBJECT(win->window), "has-toplevel-focus", &has_focus, NULL);
-
-	return has_focus;
-}
-
-PidginConvWindow *
-pidgin_conv_window_get_at_event(GdkEvent *event)
-{
-	PidginConvWindow *win;
-	GdkWindow *gdkwin;
-	GList *l;
-	int x, y;
-
-	gdkwin = gdk_device_get_window_at_position(gdk_event_get_device(event),
-	                                           &x, &y);
-
-	if (gdkwin)
-		gdkwin = gdk_window_get_toplevel(gdkwin);
-
-	for (l = pidgin_conv_windows_get_list(); l != NULL; l = l->next) {
-		win = l->data;
-
-		if (gdkwin == gtk_widget_get_window(win->window))
-			return win;
-	}
-
-	return NULL;
-}
-
-GList *
-pidgin_conv_window_get_gtkconvs(PidginConvWindow *win)
-{
-	return win->gtkconvs;
-}
-
-guint
-pidgin_conv_window_get_gtkconv_count(PidginConvWindow *win)
-{
-	return g_list_length(win->gtkconvs);
-}
-
-void
-pidgin_conv_placement_place(PidginConversation *conv) {
-       PidginConvWindow *win;
-
-       GList *l = g_list_last(pidgin_conv_windows_get_list());
-       win = l ? l->data : NULL;;
-
-       if (win == NULL) {
-               win = pidgin_conv_window_new();
-
-               g_signal_connect(G_OBJECT(win->window), "configure_event",
-                               G_CALLBACK(gtk_conv_configure_cb), NULL);
-
-               pidgin_conv_window_add_gtkconv(win, conv);
-               pidgin_conv_window_show(win);
-       } else {
-               pidgin_conv_window_add_gtkconv(win, conv);
-       }
-}
diff --git a/pidgin/meson.build b/pidgin/meson.build
--- a/pidgin/meson.build
+++ b/pidgin/meson.build
@@ -64,7 +64,6 @@
 	'gtkblist.h',
 	'gtkconn.h',
 	'gtkconv.h',
-	'gtkconvwin.h',
 	'gtkdialogs.h',
 	'gtkidle.h',
 	'gtkmedia.h',
diff --git a/pidgin/pidginconversationwindow.h b/pidgin/pidginconversationwindow.h
--- a/pidgin/pidginconversationwindow.h
+++ b/pidgin/pidginconversationwindow.h
@@ -31,6 +31,8 @@
 
 #include <gtk/gtk.h>
 
+#include <purple.h>
+
 G_BEGIN_DECLS
 
 /**
@@ -55,17 +57,147 @@
 GtkWidget *pidgin_conversation_window_new(void);
 
 /**
- * pidgin_conversation_window_get_vbox:
+ * pidgin_conversation_window_get_default:
+ *
+ * Gets or creates the default conversation window.
+ *
+ * Returns: (transfer none): The default #PidginConversationWindow.
+ *
+ * Since: 3.0.0
+ */
+GtkWidget *pidgin_conversation_window_get_default(void);
+
+/**
+ * pidgin_conversation_window_add:
  * @window: The #PidginConversationWindow instance.
+ * @conversation: The #PurpleConversation to add to @window.
+ *
+ * Adds @conversation to @window. If @conversation is already in @window, this
+ * does nothing.
+ *
+ * Since: 3.0.0
+ */
+void pidgin_conversation_window_add(PidginConversationWindow *window, PurpleConversation *conversation);
+
+/**
+ * pidgin_conversation_window_remove:
+ * @window: The #PidginConversationWindow instance.
+ * @conversation: The #PurpleConversation to remove from @window.
+ *
+ * Removes @conversation from @window. If @conversation is not in @window, this
+ * does nothing.
  *
- * Gets the main vertical box of @window.
+ * Since: 3.0.0
+ */
+void pidgin_conversation_window_remove(PidginConversationWindow *window, PurpleConversation *conversation);
+
+/**
+ * pidgin_conversation_window_get_count:
+ * @window: The conversation window instance.
+ *
+ * Gets the number of conversations that @window contains.
+ *
+ * Returns: The number of conversations that @window contains.
  *
- * Returns: (transfer none): The main vertical box of @window.
+ * Since: 3.0.0
+ */
+guint pidgin_conversation_window_get_count(PidginConversationWindow *window);
+
+/**
+ * pidgin_conversation_window_get_selected:
+ * @window: The conversation window instance.
+ *
+ * Gets the currently selected PurpleConversation or %NULL if there is no
+ * selection.
+ *
+ * Returns: (transfer full): The selected PurpleConversation or %NULL.
+ *
+ * Since: 3.0.0
+ */
+PurpleConversation *pidgin_conversation_window_get_selected(PidginConversationWindow *window);
+
+/**
+ * pidgin_conversation_window_select:
+ * @window: The conversation window instance.
+ * @conversation: The conversation to select.
+ *
+ * Selects @conversation, making it the active conversation.
  *
  * Since: 3.0.0
- * Deprecated: 3.0.0
+ */
+void pidgin_conversation_window_select(PidginConversationWindow *window, PurpleConversation *conversation);
+
+/**
+ * pidgin_conversation_window_select_previous:
+ * @window: The conversation window instance.
+ *
+ * Switches to the conversation previous to the currently selected
+ * conversation.
+ *
+ * If no conversation is selected, the last conversation will be selected.
+ *
+ * Since: 3.0.0
+ */
+void pidgin_conversation_window_select_previous(PidginConversationWindow *window);
+
+/**
+ * pidgin_conversation_window_select_next:
+ * @window: The conversation window instance.
+ *
+ * Switches to the conversation next of the currently selected conversation.
+ *
+ * If no conversation is selected, the first conversation will be selected.
+ *
+ * Since: 3.0.0
+ */
+void pidgin_conversation_window_select_next(PidginConversationWindow *window);
+
+/**
+ * pidgin_conversation_window_select_first:
+ * @window: The conversation window instance.
+ *
+ * Selects the first conversation in @window. If there are no conversations in
+ * @window this does nothing.
+ *
+ * Since: 3.0.0
  */
-GtkWidget *pidgin_conversation_window_get_vbox(PidginConversationWindow *window);
+void pidgin_conversation_window_select_first(PidginConversationWindow *window);
+
+/**
+ * pidgin_conversation_window_select_last:
+ * @window: The conversation window instance.
+ *
+ * Selects the last conversation in @window. If there are no conversations in
+ * @window this does nothing.
+ *
+ * Since: 3.0.0
+ */
+void pidgin_conversation_window_select_last(PidginConversationWindow *window);
+
+/**
+ * pidgin_conversation_window_select_nth:
+ * @window: The conversation window instance.
+ * @nth: The index of the conversation to switch to.
+ *
+ * Switches to the @nth conversation. @nth is a 0 based instead, so the first
+ * conversation is at index 0.
+ *
+ * Since: 3.0.0
+ */
+void pidgin_conversation_window_select_nth(PidginConversationWindow *window, guint nth);
+
+/**
+ * pidgin_conversation_window_conversation_is_selected:
+ * @window: The conversation window instance.
+ * @conversation: The conversation instance.
+ *
+ * Checks whether @conversation is the active conversation in @window.
+ *
+ * Returns: %TRUE if @conversation is active.
+ *
+ * Since: 3.0.0
+ */
+gboolean pidgin_conversation_window_conversation_is_selected(PidginConversationWindow *window, PurpleConversation *conversation);
 
 G_END_DECLS
 
